Name: e100
Summary: Intel(R) PRO/100 driver for Linux
Version: 3.0.0_dev13
Release: 1
Source: %{name}-%{version}.tar.gz
Vendor: Intel Corporation
License: GPL
ExclusiveOS: linux
Group: System Environment/Kernel
%define find() %(for f in %*; do if [ -e $f ]; then echo $f; break; fi; done)
%define _pcitable /usr/share/kudzu/pcitable /usr/share/hwdata/pcitable /dev/null
%define pcitable  %find %{_pcitable}
Requires: kernel
Provides: %{name}
URL: http://support.intel.com/support/go/linux/e100.htm
BuildRoot: %{_tmppath}/%{name}-%{version}-root

%description
This package contains the Linux driver for the
Intel(R) PRO/100 Family of Server Adapters.

%prep
%setup

%build
mkdir -p %{buildroot}

SwitchRHKernel () {
	CFLAGS_EXTRA=""
	for K in $2 ; do
		if [ $K == $1 ] ; then
			CFLAGS_EXTRA="$CFLAGS_EXTRA -D__BOOT_KERNEL_$K=1"
		else
			CFLAGS_EXTRA="$CFLAGS_EXTRA -D__BOOT_KERNEL_$K=0"
		fi
	done
}

KV=$(uname -r)

KSP="/lib/modules/$KV/build
     /usr/src/linux-$KV
     /usr/src/linux-$(echo $KV | sed 's/-.*//')
     /usr/src/kernel-headers-$KV
     /usr/src/kernel-source-$KV
     /usr/src/linux-$(echo $KV | sed 's/\([0-9]*\.[0-9]*\)\..*/\1/')
     /usr/src/linux"

KSRC=$(for d in $KSP ; do [ -e $d/include/linux ] && echo $d; echo;  done)
KSRC=$(echo $KSRC | awk '{ print $1 }')

if [ -e $KSRC/include/linux/rhconfig.h ] ; then
	RHKL=$(grep 'BOOT_KERNEL_.* [01]' /boot/kernel.h |
	       sed 's/.*BOOT_KERNEL_\(.*\) [01]/\1/')
	for K in $RHKL ; do
		if [ "$K" == "BIGMEM" ] ; then
			HAVE_BIGMEM=1
		fi
	done
	for K in $RHKL ; do
		if [ "$K" == "ENTERPRISE" -a "$HAVE_BIGMEM" ] ; then
			continue
		fi
		SwitchRHKernel $K "$RHKL"
		make -C src clean
		make -C src INSTALL_MOD_PATH=%{buildroot} \
			MANDIR=%{_mandir} CFLAGS_EXTRA="$CFLAGS_EXTRA" install
	done
else
	make -C src clean
	make -C src INSTALL_MOD_PATH=%{buildroot} MANDIR=%{_mandir} install
fi

%install
cd %{buildroot}
find lib -name e100.o -fprintf %{_builddir}/%{name}-%{version}/file.list "/%p\n"

%clean
rm -rf %{buildroot}

%files -f %{_builddir}/%{name}-%{version}/file.list
%defattr(-,root,root)
%{_mandir}/man7/e100.7.gz
%doc LICENSE
%doc README
%doc ldistrib.txt
%doc file.list

%pre
d_usr="/usr/local/lib/%{name}"
d_drivers="/lib/modules/$(uname -r)"
# If upgrade, need to remove all files under usr directory
# Otherwise, may not be able to restore previous driver
if [ $1 -eq 2 ]; then
	rm -rf $d_usr
fi
# Create top usr directory
mkdir -p $d_usr
# Move old drivers to usr directory
cd $d_drivers; find . -name %{name}.o* -exec cp --parents {} $d_usr \; -exec rm -f {} \;

%post
FL="%{_docdir}/%{name}-%{version}/file.list
    %{_docdir}/%{name}/file.list"
FL=$(for d in $FL ; do if [ -e $d ]; then echo $d; break; fi;  done)

BK_LIST=$(sed 's/\/lib\/modules\/\([0-9a-zA-Z\.\-]*\).*/\1/' $FL)
MATCH=no
for i in $BK_LIST
do
	if [ $(uname -r) == $i ] ; then
		MATCH=YES
		break
	fi
done
if [ $MATCH == no ] ; then
	echo -n "WARNING: Running kernel is $(uname -r).  "
	echo -n "RPM supports kernels (  "
	for i in $BK_LIST
	do
		echo -n "$i  "
	done
	echo ")"
fi

# If any adapters are configured to use eepro100, reconfigure to use e100.
if ( grep eepro100 /etc/modules.conf > /dev/null 2>&1 ); then
        mv -f /etc/modules.conf /etc/modules.conf.OLD
        sed -e s/eepro100/e100/g /etc/modules.conf.OLD >> /etc/modules.conf
else
        rm -f /etc/modules.conf.OLD
fi

if [ -d /usr/src/redhat ]
then
# Update Kudzu's device table such that future devices will use e100,
# not eepro100.
if ( grep eepro100 %{pcitable} > /dev/null 2>&1 ); then
        mv -f %{pcitable} %{pcitable}.OLD
        sed -e s/eepro100/e100/g %{pcitable}.OLD >> %{pcitable}
fi
fi

uname -r | grep BOOT || /sbin/depmod -a > /dev/null 2>&1 || true

%preun

%postun
# Restore old driver if in RPM un-install.
# Do nothing if in RPM upgrade.
if [ $1 -eq 0 ]; then
	d_usr="/usr/local/lib/%{name}"
	d_drivers="/lib/modules/$(uname -r)"
# Restore old drivers
	cd $d_usr; find . -name %{name}.o* -exec cp --parents {} $d_drivers \;
# Remove usr directory
	rm -rf $d_usr
fi

# If any adapters were configured to use eepro100, restore the original.
if [ -e /etc/modules.conf.OLD ]; then
       if ( grep eepro100 /etc/modules.conf.OLD > /dev/null 2>&1 ); then
               rm -f /etc/modules.conf.OLD
               mv -f /etc/modules.conf /etc/modules.conf.OLD
               sed -e s/e100$/eepro100/g /etc/modules.conf.OLD >> /etc/modules.conf
       fi
fi

if [ -d /usr/src/redhat ]
then
# Update Kudzu's device table such that future devices that will use
# eepro100 if this was the set before e100 install.
if [ -e %{pcitable}.OLD ]; then
       if ( grep eepro100 %{pcitable}.OLD > /dev/null 2>&1 ); then
               mv -f %{pcitable} %{pcitable}.OLD
               sed -e s/\"e100\"/\"eepro100\"/g %{pcitable}.OLD >> %{pcitable}
               rm -f %{pcitable}.OLD
       fi
fi
fi

uname -r | grep BOOT || /sbin/depmod -a > /dev/null 2>&1 || true

